Subject: [Rfc-markdown] How to cite this DOI?

From: Lars Eggert <[email-masked]>
Date: Fri, 15 Oct 2021 11:17:04 +0300

Hi,

trying to cite https://www.sciencedirect.com/science/article/abs/pii/0169755289900196?via%3Dihub with DOI URL https://doi.org/10.1016/0169-7552(89)90019-6.

I think the parenthesis in the URL are causing issues, as kramdown-rfc2629 is trying to retrieve https://xml2rfc.tools.ietf.org/public/rfc/bibxml7/reference.DOI.10.1016/0169-7552.xml and failing.

Any hints?

Thanks,
Lars

---

From: Carsten Bormann <[email-masked]>
Date: Fri, 15 Oct 2021 12:04:19 +0200

Hi Lars,

> I think the parenthesis in the URL are causing issues, as kramdown-rfc2629 is trying to retrieve https://xml2rfc.tools.ietf.org/public/rfc/bibxml7/reference.DOI.10.1016/0169-7552.xml and failing.

Worked around now in 1.5.10.

> Any hints?

Is there a defined syntax for DOIs?
(What other weird characters are allowed in there?)

Grüße, Carsten

---

From: Lars Eggert <[email-masked]>
Date: Fri, 15 Oct 2021 13:36:15 +0300

Hi,

> Worked around now in 1.5.10.

thanks!

> (What other weird characters are allowed in there?)

I have no idea. The whole DOI thing seems pretty sloppily put together; unfortunately it's what the publishing industry adopted though.

For example, https://dl.acm.org/doi/10.5555/206746 has a DOI via the ACM that doi.org refuses to resolve. Fun.

Lars

---

From: Carsten Bormann <[email-masked]>
Date: Fri, 15 Oct 2021 13:18:23 +0200

> I have no idea. The whole DOI thing seems pretty sloppily put together; unfortunately it's what the publishing industry adopted though.

That was easy:

https://www.doi.org/doi_handbook/2_Numbering.html#2.2.1

>> The DOI name is case-insensitive and can incorporate any printable characters from the legal graphic characters of Unicode. Further constraints on character use (e.g. use of language-specific alphanumeric characters) can be defined for an application by the ISO 26324 Registration Authority.

You can’t make this stuff up.

> For example, https://dl.acm.org/doi/10.5555/206746 has a DOI via the ACM that doi.org refuses to resolve. Fun.

That is a different thing, as John Levine explained to me.
Books don’t have DOIs, but ACM uses a DOI-like namespace for books.
(Doesn’t anyone think of the children^W users?)

Grüße, Carsten

---

From: "John Levine" <[email-masked]>
Date: 15 Oct 2021 17:02:33 -0400

It appears that Carsten Bormann  <[email-masked]> said:
>>> The DOI name is case-insensitive and can incorporate any printable characters from the legal graphic characters of Unicode. Further constraints on
>character use (e.g. use of language-specific alphanumeric characters) can be defined for an application by the ISO 26324 Registration Authority.
>

How soon they forget.  DOIs are an instance of the handle system, whose syntax is defined in RFC 3651.  It does indeed allow any UTF-8 encoded
Unicode 2.0 character, but since the handle system also had its own retrieval protocol, quoting wasn't a problem.

Except that nobody ever used the handle protocol so the only popular application of handles, DOI, made an expedient
choice to use http instead, turning the handles into URLs.  Unfortunately, the DOI people are librarians, not
computer standards experts and may have missed the fine points of what goes into a URL.

Having said that, what's the problem with that URL?  RFC 1738 specifically says that unencoded parentheses in a URL are allowed.
I tried pasting it into Brave (based on Chrome), Safari, and Firefox, and it worked fine.  If you have some tool that barfs
on them, you can always percent encode them.

R's,
John

---

From: Carsten Bormann <[email-masked]>
Date: Sat, 16 Oct 2021 02:46:26 +0200

> Unicode 2.0 character, but since the handle system also had its own retrieval protocol, quoting wasn't a problem.

Does “printable character” include ZWNJ?  If not, how do I get a correct representation of the Auf‌lage (*) of a digital object?
The term “case-insensitive” doesn’t even mean anything without a locale.
(Well, you know all this, but I want to remind everyone why this choice just boggles the mind.)

> computer standards experts and may have missed the fine points of what goes into a URL.

The URL representation is not the problem here.

> on them, you can always percent encode them.

Parentheses are just fine in a URL (e.g., I use them all the time on cbor.me [1]).
Everything is wrong about using anything but [-A-Za-z0-9.]+ in the components of a DOI [2]; Elsevier would not have had to do that.

                    .oOo.

So the payload of this message is that I have added the parentheses for the YAML prelude in 1.5.10, but we have to be a bit careful about what is allowed directly in {{}} (right now, once you go outside sequences of XML namechars, weird things will happen).  Because the RFC editor surely wouldn't accept anything else as a reference anchor, I don’t think this is a crippling limitation.

If you ever need more bugs 𐲃𐲡 in your DOI, just holler.

Grüße, Carsten

(*) literally print run, but often used in place of edition, look closely at how this does not have an fl ligature even in a font that has them.
[1]: http://cbor.me/?bytes=82(01-82(02-03))
[2]: https://en.wikipedia.org/wiki/Principle_of_least_astonishment

---

From: "John R Levine" <[email-masked]>
Date: 15 Oct 2021 21:53:31 -0400

> (Well, you know all this, but I want to remind everyone why this choice just boggles the mind.)

If you believe RFC 3650, handles are UTF-8 encoded Unicode 3.0, but if you 
believe the ABNF in RFC 3651, it is UTF-8 encoded Unicode 2.0.  Either 
way, ZWNJ is allowed so you are in luck.  I'm more interested in what 
happens when my handles contain uncomposed accented characters 
and surrogates.

I have no idea what "printable characters from the legal graphic 
characters of Unicode" means and neither do they since Unicode doesn't 
define printable.

> Everything is wrong about using anything but [-A-Za-z0-9.]+ in the components of a DOI [2]; Elsevier would not have had to do that.

Well, yeah. You'll notice the handles in RFC DOIs currently include the 
letters R, F, C, and digits 0-9.  I considered being more clever but 
decided not to.

Regards,
John Levine, [email-masked], Taughannock Networks, Trumansburg NY
Please consider the environment before reading this e-mail. https://jl.ly